Index: trunk/LMDZ.GENERIC/libf/phystd/mass_redistribution.F90
===================================================================
--- trunk/LMDZ.GENERIC/libf/phystd/mass_redistribution.F90	(revision 728)
+++ trunk/LMDZ.GENERIC/libf/phystd/mass_redistribution.F90	(revision 728)
@@ -0,0 +1,404 @@
+      SUBROUTINE mass_redistribution(ngrid,nlayer,nq,ptimestep,   &
+                       rnat,pcapcal,pplay,pplev,pt,ptsrf,pq,pqs,     &
+		       pu,pv,pdt,pdtsrf,pdq,pdu,pdv,pdmassmr,  &
+		       pdtmr,pdtsrfmr,pdpsrfmr,pdumr,pdvmr,pdqmr,pdqsmr)
+                                                   
+       USE watercommon_h, Only: Tsat_water,RLVTT
+
+       IMPLICIT NONE
+!=======================================================================
+!   subject:
+!   --------
+!     Mass and momentum fluxes through sigma levels as the surface pressure is modified are also taken into account
+!
+!   author:   Jeremy Leconte 2012 (from F.Forget 1998)
+!   ------
+!
+!   input:
+!   ----- 
+!    ngrid                 nombre de points de verticales
+!                          (toutes les boucles de la physique sont au
+!                          moins vectorisees sur ngrid)
+!    nlayer                nombre de couches
+!    pplay(ngrid,nlayer)   Pressure levels 
+!    pplev(ngrid,nlayer+1) Pressure levels 
+!    nq                    Number of tracers
+!
+!    pt(ngrid,nlayer)      temperature (en K)
+!    pq(ngrid,nlayer,nq)   tracer specific concentration (kg/kg of air)
+!    pu,pv (ngrid,nlayer)  wind velocity (m/s)
+!
+!                    
+!    pdX                   physical tendency of X before mass redistribution
+!
+!    pdmassmr                air Mass added to the atmosphere in each layer (kg/m2/s)
+!
+!   output:
+!   -------
+!
+!    pdXmr(ngrid)           physical tendency of X after mass redistribution
+!
+!    
+!
+!=======================================================================
+!
+!    0.  Declarations :
+!    ------------------
+!
+#include "dimensions.h"
+#include "dimphys.h"
+#include "comcstfi.h"
+#include "surfdat.h"
+#include "comgeomfi.h"
+#include "comvert.h"
+#include "paramet.h"
+#include "callkeys.h"
+#include "tracer.h"
+
+!-----------------------------------------------------------------------
+!    Arguments :
+!    ---------
+      INTEGER ngrid, nlayer, nq   
+      REAL ptimestep
+      REAL pcapcal(ngridmx)
+      INTEGER rnat(ngridmx)      
+      REAL pplay(ngrid,nlayer),pplev(ngrid,nlayer+1)
+      REAL pt(ngrid,nlayer),pdt(ngrid,nlayer)
+      REAL ptsrf(ngrid),pdtsrf(ngrid)
+      REAL pdtmr(ngrid,nlayer)
+      REAL pu(ngrid,nlayer) ,  pv(ngrid,nlayer)
+      REAL pdu(ngrid,nlayer) , pdv(ngrid,nlayer)
+      REAL pdmassmr(ngrid,nlayer)
+      REAL pdumr(ngrid,nlayer) , pdvmr(ngrid,nlayer)
+      REAL pq(ngridmx,nlayer,nq),pdq(ngrid,nlayer,nq)
+      REAL pqs(ngridmx,nq)
+      REAL pdqmr(ngrid,nlayer,nq),pdqsmr(ngrid,nq)
+      REAL pdpsrfmr(ngrid),pdtsrfmr(ngrid)
+!
+!    Local variables :
+!    -----------------
+
+!    Boiling/sublimation
+      REAL Tsat(ngridmx),zmassboil(ngridmx)
+
+!    vertical reorganization of sigma levels
+      REAL zzu(nlayermx),zzv(nlayermx)
+      REAL zzq(nlayermx,nq),zzt(nlayermx)
+!    Dummy variables      
+      INTEGER n,l,ig,iq
+      REAL zdtsig(ngridmx,nlayermx)
+      REAL zmass(ngridmx,nlayermx),zzmass(nlayermx),w(nlayermx+1)
+      REAL zdmass_sum(ngridmx,nlayermx+1)
+      REAL zmflux(nlayermx+1)
+      REAL zq1(nlayermx)
+      REAL ztsrf(ngridmx)
+      REAL ztm(nlayermx+1) 
+      REAL zum(nlayermx+1) , zvm(nlayermx+1)
+      REAL zqm(nlayermx+1,nqmx),zqm1(nlayermx+1)
+
+!   local saved variables
+      LOGICAL, SAVE :: firstcall=.true.
+
+!----------------------------------------------------------------------
+
+!   Initialisation
+!   --------------
+!
+      IF (firstcall) THEN
+         firstcall=.false.	 
+      ENDIF
+!
+!======================================================================
+!    Calcul of h2o condensation  
+!    ============================================================
+!  
+!    Used variable :
+!       pdmassmr      : air Mass added to the atmosphere in each layer per unit time (kg/m2/s)
+!       zdmass_sum(ngrid,l) : total air mass added to the atm above layer l per unit time (kg/m2/s)
+!
+!
+!     Surface tracer Tendencies set to 0
+!     -------------------------------------
+      pdqsmr(1:ngridmx,1:nqmx)=0.
+
+      ztsrf(1:ngridmx) = ptsrf(1:ngridmx) + pdtsrf(1:ngridmx)*ptimestep
+
+
+      DO ig=1,ngrid
+         zdmass_sum(ig,nlayermx+1)=0.
+         DO l = nlayermx, 1, -1
+           zmass(ig,l) = (pplev(ig,l)-pplev(ig,l+1))/g
+	   zdmass_sum(ig,l)= zdmass_sum(ig,l+1)+pdmassmr(ig,l)
+         END DO
+      END DO
+
+
+      if (water) then
+         do ig=1,ngridmx
+	    call Tsat_water(pplev(ig,1)+zdmass_sum(ig,1)*g*ptimestep,Tsat(ig))
+	 enddo
+               call writediagfi(ngrid,'Tsat','saturation temperature at surface','',2,Tsat)
+	 
+         do ig=1,ngridmx
+	    if (ztsrf(ig).gt.Tsat(ig)) then
+	       zmassboil(ig)=(ptsrf(ig)-Tsat(ig))*pcapcal(ig)/RLVTT/ptimestep
+	       if ((zmassboil(ig)*ptimestep.gt.pqs(ig,igcm_h2o_vap)).and.(rnat(ig).eq.1)) then
+	          zmassboil(ig)=pqs(ig,igcm_h2o_vap)/ptimestep
+	       endif
+	       zmassboil(ig)=zmassboil(ig)*0.3 !momentary, should be 1. JL12
+               pdqsmr(ig,igcm_h2o_vap)=-zmassboil(ig)
+	       pdtsrfmr(ig)=-zmassboil(ig)*RLVTT/pcapcal(ig)
+	       ztsrf(ig)=ptsrf(ig)+pdtsrfmr(ig)*ptimestep
+	    else
+	       zmassboil(ig)=0.
+	       pdtsrfmr(ig)=0.
+	    endif
+	 enddo
+      endif
+
+!     *************************
+!           UPDATE SURFACE
+!     *************************
+!    Changing pressure at the surface:
+!    """"""""""""""""""""""""""""""""""""
+         
+      pdpsrfmr(1:ngridmx) = (zdmass_sum(1:ngridmx,1)+zmassboil(1:ngridmx))*g
+
+      do ig = 1, ngridmx
+        IF(ABS(pdpsrfmr(ig)*ptimestep).GT.pplev(ig,1)) THEN
+         PRINT*,'STOP in condens'
+         PRINT*,'condensing more than total mass'
+         PRINT*,'Grid point ',ig
+         PRINT*,'Ps = ',pplev(ig,1)
+         PRINT*,'d Ps = ',pdpsrfmr(ig)*ptimestep
+         STOP
+        ENDIF
+      enddo ! of DO ig=1,ngrid
+
+
+! ***************************************************************
+!  Correction to account for redistribution between sigma or hybrid 
+!  layers when changing surface pressure
+!  zzx quantities have dimension (nlayermx) to speed up calculation
+! *************************************************************
+
+      DO ig=1,ngrid
+         zzt(1:nlayermx)  = pt(ig,1:nlayermx) + pdt(ig,1:nlayermx) * ptimestep
+         zzu(1:nlayermx)  = pu(ig,1:nlayermx) + pdu(ig,1:nlayermx) * ptimestep
+         zzv(1:nlayermx)  = pv(ig,1:nlayermx) + pdv(ig,1:nlayermx) * ptimestep
+         zzq(1:nlayermx,1:nqmx)=pq(ig,1:nlayermx,1:nqmx)+pdq(ig,1:nlayermx,1:nqmx)*ptimestep ! must add the water that has fallen???
+
+!  Mass fluxes of air through the sigma levels (kg.m-2.s-1)  (>0 when up)
+!  """"""""""""""""""""""""""""""""""""""""""""""""""""""""""""""
+
+         zmflux(1) = zmassboil(ig)
+         DO l=1,nlayer
+            zmflux(l+1) = zmflux(l) + pdmassmr(ig,l) - (bp(l)-bp(l+1))*(zdmass_sum(ig,1)+zmflux(1))
+! zmflux set to 0 if very low to avoid: top layer is disappearing in v1ld  
+            if (abs(zmflux(l+1)).lt.1E-13.OR.bp(l+1).eq.0.) zmflux(l+1)=0.
+         END DO
+
+! Mass of each layer
+! ------------------ 
+         zzmass(1:nlayermx)=zmass(ig,1:nlayermx)*(1.+pdpsrfmr(ig)*ptimestep/pplev(ig,1))
+
+
+!  Corresponding fluxes for T,U,V,Q
+!  """"""""""""""""""""""""""""""""
+
+!        averaging operator for TRANSPORT  
+!        """"""""""""""""""""""""""""""""
+!        Value transfert at the surface interface when condensation
+!        sublimation:
+         ztm(1) = ztsrf(ig)
+         zum(1) = 0.  
+         zvm(1) = 0.  
+         zqm(1,1:nqmx)=0. ! most tracer do not condense !
+         if (water) zqm(1,igcm_h2o_vap)=1. ! flux is 100% h2o at surface
+	 
+!        Van Leer scheme:
+         w(1:nlayermx+1)=-zmflux(1:nlayermx+1)*ptimestep
+         call vl1d(zzt,2.,zzmass,w,ztm) 
+         call vl1d(zzu ,2.,zzmass,w,zum) 
+         call vl1d(zzv ,2.,zzmass,w,zvm) 
+         do iq=1,nqmx
+           zq1(1:nlayermx)=zzq(1:nlayermx,iq)
+           zqm1(1)=zqm(1,iq)
+!		print*,iq
+!		print*,zq1
+           call vl1d(zq1,2.,zzmass,w,zqm1)
+           do l=2,nlayer
+              zzq(l,iq)=zq1(l)
+              zqm(l,iq)=zqm1(l)
+           enddo
+         enddo
+
+!        Surface condensation affects low winds
+         if (zmflux(1).lt.0) then 
+            zum(1)= zzu(1) *  (w(1)/zzmass(1))
+            zvm(1)= zzv(1) *  (w(1)/zzmass(1))
+            if (w(1).gt.zzmass(1)) then ! ensure numerical stability
+               zum(1)= (zzu(1)-zum(2))*zzmass(1)/w(1) + zum(2)
+               zvm(1)= (zzv(1)-zvm(2))*zzmass(1)/w(1) + zvm(2)
+            end if
+         end if
+                    
+         ztm(nlayer+1)= zzt(nlayer) ! should not be used, but... 
+         zum(nlayer+1)= zzu(nlayer)  ! should not be used, but...
+         zvm(nlayer+1)= zzv(nlayer)  ! should not be used, but...
+         zqm(nlayer+1,1:nqmx)= zzq(nlayer,1:nqmx)
+ 
+!        Tendencies on T, U, V, Q 
+!        """"""""""""""""""""""""
+         DO l=1,nlayer
+ 
+!           Tendencies on T
+            pdtmr(ig,l) = (1/zzmass(l)) *   &
+		(zmflux(l)*(ztm(l) - zzt(l))-zmflux(l+1)*(ztm(l+1)-zzt(l)))
+		  !JL12 the last term in Newcondens has been set to zero because we are only dealing with redistribution here
+
+!           Tendencies on U
+            pdumr(ig,l)   = (1/zzmass(l)) *( zmflux(l)*(zum(l) - zzu(l)) - zmflux(l+1)*(zum(l+1) - zzu(l)) )
+
+!           Tendencies on V
+            pdvmr(ig,l)   = (1/zzmass(l)) *( zmflux(l)*(zvm(l) - zzv(l)) - zmflux(l+1)*(zvm(l+1) - zzv(l)) )
+
+         END DO
+
+!        Tendencies on Q
+         do iq=1,nqmx
+            DO l=1,nlayer
+               pdqmr(ig,l,iq)= (1/zzmass(l)) *   &
+		   (zmflux(l)*(zqm(l,iq)-zzq(l,iq))- zmflux(l+1)*(zqm(l+1,iq)-zzq(l,iq)) - pdmassmr(ig,l)*zzq(l,iq))
+            END DO
+         enddo
+
+      END DO  ! loop on ig 
+
+      return
+      end
+
+
+
+! *****************************************************************
+      SUBROUTINE vl1d(q,pente_max,zzmass,w,qm)
+!
+!    
+!     Operateur de moyenne inter-couche pour calcul de transport type
+!     Van-Leer " pseudo amont " dans la verticale
+!    q,w sont des arguments d'entree  pour le s-pg ....
+!    masse : masse de la couche Dp/g
+!    w : masse d'atm ``transferee'' a chaque pas de temps (kg.m-2)
+!    pente_max = 2 conseillee
+!
+!
+!   --------------------------------------------------------------------
+      IMPLICIT NONE
+
+#include "dimensions.h"
+
+!   Arguments:
+!   ----------
+      real zzmass(llm),pente_max
+      REAL q(llm),qm(llm+1)
+      REAL w(llm+1)
+!
+!      Local 
+!   ---------
+!
+      INTEGER l
+!
+      real dzq(llm),dzqw(llm),adzqw(llm),dzqmax
+      real sigw, Mtot, MQtot
+      integer m 
+!     integer ismax,ismin 
+
+
+!    On oriente tout dans le sens de la pression 
+!     W > 0 WHEN DOWN !!!!!!!!!!!!!
+
+      do l=2,llm
+            dzqw(l)=q(l-1)-q(l)
+            adzqw(l)=abs(dzqw(l))
+      enddo
+
+      do l=2,llm-1
+            if(dzqw(l)*dzqw(l+1).gt.0.) then
+                dzq(l)=0.5*(dzqw(l)+dzqw(l+1))
+            else
+                dzq(l)=0.
+            endif
+            dzqmax=pente_max*min(adzqw(l),adzqw(l+1))
+            dzq(l)=sign(min(abs(dzq(l)),dzqmax),dzq(l))
+      enddo
+
+         dzq(1)=0.
+         dzq(llm)=0.
+
+       do l = 1,llm-1
+
+!         Regular scheme (transfered mass < layer mass)
+!         ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+          if(w(l+1).gt.0. .and. w(l+1).le.zzmass(l+1)) then
+             sigw=w(l+1)/zzmass(l+1)
+             qm(l+1)=(q(l+1)+0.5*(1.-sigw)*dzq(l+1))
+          else if(w(l+1).le.0. .and. -w(l+1).le.zzmass(l)) then
+             sigw=w(l+1)/zzmass(l)
+             qm(l+1)=(q(l)-0.5*(1.+sigw)*dzq(l))
+
+!         Extended scheme (transfered mass > layer mass)
+!         ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+          else if(w(l+1).gt.0.) then
+             m=l+1
+             Mtot = zzmass(m)
+             MQtot = zzmass(m)*q(m)
+             do while ((m.lt.llm).and.(w(l+1).gt.(Mtot+zzmass(m+1))))
+                m=m+1
+                Mtot = Mtot + zzmass(m)
+                MQtot = MQtot + zzmass(m)*q(m)
+             end do
+             if (m.lt.llm) then
+                sigw=(w(l+1)-Mtot)/zzmass(m+1)
+                qm(l+1)= (1/w(l+1))*(MQtot + (w(l+1)-Mtot)*(q(m+1)+0.5*(1.-sigw)*dzq(m+1)) )
+             else
+!                w(l+1) = Mtot
+!                qm(l+1) = Mqtot / Mtot
+                write(*,*) 'top layer is disappearing !',l,Mtot,w(l+1),qm(l+1)
+		print*,zzmass
+ 		print*,w
+		print*,q
+		print*,qm
+               stop
+             end if
+          else      ! if(w(l+1).lt.0) 
+             m = l-1 
+             Mtot = zzmass(m+1)
+             MQtot = zzmass(m+1)*q(m+1)
+             if (m.gt.0) then ! because some compilers will have problems
+                              ! evaluating zzmass(0)
+              do while ((m.gt.0).and.(-w(l+1).gt.(Mtot+zzmass(m))))
+                m=m-1
+                Mtot = Mtot + zzmass(m+1)
+                MQtot = MQtot + zzmass(m+1)*q(m+1)
+                if (m.eq.0) exit
+              end do
+             endif
+             if (m.gt.0) then
+                sigw=(w(l+1)+Mtot)/zzmass(m)
+                qm(l+1)= (-1/w(l+1))*(MQtot + (-w(l+1)-Mtot)*(q(m)-0.5*(1.+sigw)*dzq(m))  )
+             else
+                qm(l+1)= (-1/w(l+1))*(MQtot + (-w(l+1)-Mtot)*qm(1))
+             end if   
+          end if
+       enddo
+
+!     boundary conditions (not used in newcondens !!)
+!         qm(llm+1)=0.
+!         if(w(1).gt.0.) then
+!            qm(1)=q(1)
+!         else 
+!           qm(1)=0.
+!         end if
+
+      return
+      end
Index: trunk/LMDZ.GENERIC/libf/phystd/moistadj.F90
===================================================================
--- trunk/LMDZ.GENERIC/libf/phystd/moistadj.F90	(revision 726)
+++ trunk/LMDZ.GENERIC/libf/phystd/moistadj.F90	(revision 728)
@@ -1,5 +1,5 @@
-subroutine moistadj(t, pq, pplev, pplay, dtmana, dqmana, ptimestep, rneb)
-
-  use watercommon_h, only: T_h2O_ice_liq, RLVTT, RCPD
+subroutine moistadj(pt, pq, pdq, pplev, pplay, pdtmana, pdqmana, ptimestep, rneb)
+
+  use watercommon_h, only: T_h2O_ice_liq, RLVTT, RCPD, Psat_water, Lcpdqsat_water
 
   implicit none
@@ -24,14 +24,14 @@
 #include "comcstfi.h"
 
-!     Pre-arguments (for universal model)
-      real pq(ngridmx,nlayermx,nqmx)       ! tracer (kg/kg)
+      REAL pt(ngridmx,nlayermx)            ! temperature (K)
+      REAL pq(ngridmx,nlayermx,nqmx)       ! tracer (kg/kg)
       REAL pdq(ngridmx,nlayermx,nqmx)
 
-      real dqmana(ngridmx,nlayermx,nqmx)   ! tendency of tracers (kg/kg.s-1)
-      REAL dtmana(ngridmx,nlayermx)        ! temperature increment
-
-!     Arguments
-      REAL t(ngridmx,nlayermx)       ! temperature (K)
-      REAL q(ngridmx,nlayermx)       ! humidite specifique (kg/kg)
+      REAL pdqmana(ngridmx,nlayermx,nqmx)  ! tendency of tracers (kg/kg.s-1)
+      REAL pdtmana(ngridmx,nlayermx)       ! temperature increment
+
+!     local variables
+      REAL zt(ngridmx,nlayermx)      ! temperature (K)
+      REAL zq(ngridmx,nlayermx)      ! humidite specifique (kg/kg)
       REAL pplev(ngridmx,nlayermx+1) ! pression a inter-couche (Pa)
       REAL pplay(ngridmx,nlayermx)   ! pression au milieu de couche (Pa)
@@ -49,5 +49,6 @@
 
 !     Local variables
-      INTEGER i, k, iq
+      INTEGER i, k, iq, nn
+      INTEGER, PARAMETER :: niter = 6
       INTEGER k1, k1p, k2, k2p
       LOGICAL itest(ngridmx)
@@ -55,8 +56,7 @@
       REAL cp_new_t(nlayermx)
       REAL cp_delta_t(nlayermx)
-      REAL new_qb(nlayermx)
       REAL v_cptj(nlayermx), v_cptjk1, v_ssig
-      REAL v_cptt(ngridmx,nlayermx), v_p, v_t
-      REAL v_qs(ngridmx,nlayermx), v_qsd(ngridmx,nlayermx)
+      REAL v_cptt(ngridmx,nlayermx), v_p, v_t, zpsat
+      REAL zqs(ngridmx,nlayermx), zdqs(ngridmx,nlayermx)
       REAL zq1(ngridmx), zq2(ngridmx)
       REAL gamcpdz(ngridmx,2:nlayermx)
@@ -94,29 +94,22 @@
 
 !     GCM -----> subroutine variables
-      DO k = 1, nlayermx
-      DO i = 1, ngridmx
-
-         q(i,k)    = pq(i,k,i_h2o)
-
-         if(q(i,k).lt.0.)then
-            q(i,k)=0.0
+      zq(1:ngridmx,1:nlayermx)    = pq(1:ngridmx,1:nlayermx,i_h2o)+ pdq(1:ngridmx,1:nlayermx,i_h2o)*ptimestep
+      zt(1:ngridmx,1:nlayermx)    = pt(1:ngridmx,1:nlayermx)
+      pdqmana(1:ngridmx,1:nlayermx,1:nqmx)=0.0
+
+      DO k = 1, nlayermx
+       DO i = 1, ngridmx
+         if(zq(i,k).lt.0.)then
+            zq(i,k)=0.0
          endif
-         DO iq = 1, nqmx
-            dqmana(i,k,iq)=0.0
-         ENDDO
-      ENDDO
-      ENDDO
-
-      DO k = 1, nlayermx
-         DO i = 1, ngridmx
-            local_q(i,k) = q(i,k)
-            local_t(i,k) = t(i,k)
-            rneb(i,k) = 0.0
-            d_ql(i,k) = 0.0
-            d_t(i,k)  = 0.0
-            d_q(i,k)  = 0.0
-         ENDDO
-         new_qb(k)=0.0
-      ENDDO
+       ENDDO
+      ENDDO
+      
+      local_q(1:ngridmx,1:nlayermx) = zq(1:ngridmx,1:nlayermx)
+      local_t(1:ngridmx,1:nlayermx) = zt(1:ngridmx,1:nlayermx)
+      rneb(1:ngridmx,1:nlayermx) = 0.0
+      d_ql(1:ngridmx,1:nlayermx) = 0.0
+      d_t(1:ngridmx,1:nlayermx)  = 0.0
+      d_q(1:ngridmx,1:nlayermx)  = 0.0
 
 !     Calculate v_cptt
@@ -124,23 +117,11 @@
          DO i = 1, ngridmx
             v_cptt(i,k) = RCPD * local_t(i,k)
-            v_t = local_t(i,k)
+            v_t = MAX(local_t(i,k),15.)
             v_p = pplay(i,k)
 
-            call watersat(v_t,v_p,v_qs(i,k))
-            call watersat_grad(v_t,v_qs(i,k),v_qsd(i,k))
+            call Psat_water(v_t,v_p,zpsat,zqs(i,k))
+	    call Lcpdqsat_water(v_t,v_p,zpsat,zqs(i,k),zdqs(i,k))
          ENDDO
       ENDDO
-
-!     TEST: RH DIAGNOSTIC
-!      DO k = 1, nlayermx
-!         DO i = 1, ngridmx
-!            v_t = local_t(i,k)
-!            IF (v_t.LT.T_h2O_ice_liq) THEN
-!               print*,'RHs=',q(i,k) / v_qs(i,k)
-!            ELSE
-!               print*,'RHl=',q(i,k) / v_qs(i,k)
-!            ENDIF
-!         ENDDO
-!      ENDDO
 
 !     Calculate Gamma * Cp * dz: (gamma is the critical gradient)
@@ -149,12 +130,8 @@
             zdp = pplev(i,k)-pplev(i,k+1)
             zdpm = pplev(i,k-1)-pplev(i,k)
-!         gamcpdz(i,k) = ( ( RD/RCPD /(zdpm+zdp) * 
-            gamcpdz(i,k) = ( ( R/RCPD /(zdpm+zdp) *             &
-                (v_cptt(i,k-1)*zdpm + v_cptt(i,k)*zdp)          &
-                +RLVTT /(zdpm+zdp) *                            &
-                (v_qs(i,k-1)*zdpm + v_qs(i,k)*zdp)              &
-                )* (pplay(i,k-1)-pplay(i,k)) / pplev(i,k) )     &
-                / (1.0+(v_qsd(i,k-1)*zdpm+                      &
-                v_qsd(i,k)*zdp)/(zdpm+zdp) )                    
+            gamcpdz(i,k) = ( ( R/RCPD /(zdpm+zdp) * (v_cptt(i,k-1)*zdpm + v_cptt(i,k)*zdp)          &
+                +  RLVTT /(zdpm+zdp) * (zqs(i,k-1)*zdpm + zqs(i,k)*zdp) )                           &
+	        * (pplay(i,k-1)-pplay(i,k)) / pplev(i,k) )                                          &
+                / (1.0+ (zdqs(i,k-1)*zdpm + zdqs(i,k)*zdp)/(zdpm+zdp) )                    
          ENDDO
       ENDDO
@@ -174,6 +151,6 @@
       IF (k2 .GT. nlayermx) GOTO 9999
       zflo = v_cptt(i,k2-1) - v_cptt(i,k2) - gamcpdz(i,k2)
-      zsat=(local_q(i,k2-1)-v_qs(i,k2-1))*(pplev(i,k2-1)-pplev(i,k2))   &
-         +(local_q(i,k2)-v_qs(i,k2))*(pplev(i,k2)-pplev(i,k2+1))
+      zsat=(local_q(i,k2-1)-zqs(i,k2-1))*(pplev(i,k2-1)-pplev(i,k2))   &
+         +(local_q(i,k2)-zqs(i,k2))*(pplev(i,k2)-pplev(i,k2+1))
 
       IF ( zflo.LE.0.0 .OR. zsat.LE.0.0 ) GOTO 810
@@ -184,5 +161,5 @@
       IF (k2 .EQ. nlayermx) GOTO 821
       k2p = k2 + 1
-      zsat=zsat+(pplev(i,k2p)-pplev(i,k2p+1))*(local_q(i,k2p)-v_qs(i,k2p))
+      zsat=zsat+(pplev(i,k2p)-pplev(i,k2p+1))*(local_q(i,k2p)-zqs(i,k2p))
       zflo = v_cptt(i,k2p-1) - v_cptt(i,k2p) - gamcpdz(i,k2p)
 
@@ -194,9 +171,9 @@
 !------------------------------------------------------ local adjustment
   830 CONTINUE ! actual adjustment
+    Do nn=1,niter
       v_cptj(k1) = 0.0
       zdp = pplev(i,k1)-pplev(i,k1+1)
-      v_cptjk1 = ( (1.0+v_qsd(i,k1))*(v_cptt(i,k1)+v_cptj(k1))        &
-                    + RLVTT*(local_q(i,k1)-v_qs(i,k1)) ) * zdp
-      v_ssig = zdp * (1.0+v_qsd(i,k1))
+      v_cptjk1 = ( (1.0+zdqs(i,k1))*(v_cptt(i,k1)+v_cptj(k1)) + RLVTT*(local_q(i,k1)-zqs(i,k1)) ) * zdp
+      v_ssig = zdp * (1.0+zdqs(i,k1))
 
       k1p = k1 + 1
@@ -204,8 +181,6 @@
          zdp = pplev(i,k)-pplev(i,k+1)
          v_cptj(k) = v_cptj(k-1) + gamcpdz(i,k)
-         v_cptjk1 = v_cptjk1 + zdp                                    &
-                  * ( (1.0+v_qsd(i, k))*(v_cptt(i,k)+v_cptj(k))       &
-                    + RLVTT*(local_q(i,k)-v_qs(i,k)) )        
-         v_ssig = v_ssig + zdp *(1.0+v_qsd(i,k))
+         v_cptjk1 = v_cptjk1 + zdp * ( (1.0+zdqs(i, k))*(v_cptt(i,k)+v_cptj(k)) + RLVTT*(local_q(i,k)-zqs(i,k)) )        
+         v_ssig = v_ssig + zdp *(1.0+zdqs(i,k))
       ENDDO
 
@@ -215,13 +190,19 @@
          cp_new_t(k) = v_cptjk1/v_ssig - v_cptj(k)
          cp_delta_t(k) = cp_new_t(k) - v_cptt(i,k)
-         new_qb(k) = v_qs(i,k) + v_qsd(i,k)*cp_delta_t(k)/RLVTT
-         local_q(i,k) = new_qb(k)
+         v_cptt(i,k)=cp_new_t(k)
+         local_q(i,k) = zqs(i,k) + zdqs(i,k)*cp_delta_t(k)/RLVTT
          local_t(i,k) = cp_new_t(k) / RCPD
 
-!          print*,'v_qs in loop=',v_qs
-!          print*,'v_qsd in loop=',v_qsd
-!          print*,'new_qb in loop=',new_qb
-!          print*,'cp_delta_t in loop=',cp_delta_t
-      ENDDO
+         v_t = MAX(local_t(i,k),15.)
+         v_p = pplay(i,k)
+         
+         call Psat_water(v_t,v_p,zpsat,zqs(i,k))
+         call Lcpdqsat_water(v_t,v_p,zpsat,zqs(i,k),zdqs(i,k))
+
+
+
+!          print*,'i,k,zqs,cpdT=',i,k,zqs(i,k),cp_delta_t(k)
+      ENDDO
+    Enddo ! nn=1,niter
 
 
@@ -230,32 +211,20 @@
 !              -- the layer about to be adjusted
 
-      DO k = k1, k2
-         v_cptt(i,k) = RCPD * local_t(i,k)
-         v_t = local_t(i,k)
-         v_p = pplay(i,k)
-
-!           IF (v_t.LT.t_coup) THEN
-!              v_qs(i,k) = qsats(v_t) / v_p
-!              v_qsd(i,k) = dqsats(v_t,v_qs(i,k))
-!           ELSE
-!              v_qs(i,k) = qsatl(v_t) / v_p
-!              v_qsd(i,k) = dqsatl(v_t,v_qs(i,k))
-!           ENDIF
-
-         call watersat(v_t,v_p,v_qs(i,k))
-         call watersat_grad(v_t,v_qs(i,k),v_qsd(i,k))
-
-      ENDDO
+!      DO k = k1, k2
+!         v_cptt(i,k) = RCPD * local_t(i,k)
+!         v_t = local_t(i,k)
+!         v_p = pplay(i,k)
+!       
+!         call Psat_water(v_t,v_p,zpsat,zqs(i,k))
+!         call Lcpdqsat_water(v_t,v_p,zpsat,zqs(i,k),zdqs(i,k))
+!      ENDDO
+
       DO k = 2, nlayermx
          zdpm = pplev(i,k-1) - pplev(i,k)
          zdp = pplev(i,k) - pplev(i,k+1)
-!         gamcpdz(i,k) = ( ( RD/RCPD /(zdpm+zdp) *
-         gamcpdz(i,k) = ( ( R/RCPD /(zdpm+zdp) *                       &
-                           (v_cptt(i,k-1)*zdpm+v_cptt(i,k)*zdp)        &
-                          +RLVTT /(zdpm+zdp) *                         &
-                           (v_qs(i,k-1)*zdpm+v_qs(i,k)*zdp)             &
-                         )* (pplay(i,k-1)-pplay(i,k)) / pplev(i,k) )    &
-                     / (1.0+(v_qsd(i,k-1)*zdpm+v_qsd(i,k)*zdp)         &
-                           /(zdpm+zdp) )
+         gamcpdz(i,k) = ( ( R/RCPD /(zdpm+zdp) * (v_cptt(i,k-1)*zdpm + v_cptt(i,k)*zdp)             &
+                +  RLVTT /(zdpm+zdp) * (zqs(i,k-1)*zdpm + zqs(i,k)*zdp) )                           &
+                * (pplay(i,k-1)-pplay(i,k)) / pplev(i,k) )                                          &
+                / (1.0+ (zdqs(i,k-1)*zdpm + zdqs(i,k)*zdp)/(zdpm+zdp) )                    
       ENDDO
 
@@ -264,6 +233,6 @@
       IF (k1 .EQ. 1) GOTO 841 ! yes we have!
       zflo = v_cptt(i,k1-1) - v_cptt(i,k1) - gamcpdz(i,k1)
-      zsat=(local_q(i,k1-1)-v_qs(i,k1-1))*(pplev(i,k1-1)-pplev(i,k1))   &
-        + (local_q(i,k1)-v_qs(i,k1))*(pplev(i,k1)-pplev(i,k1+1))
+      zsat=(local_q(i,k1-1)-zqs(i,k1-1))*(pplev(i,k1-1)-pplev(i,k1))   &
+        + (local_q(i,k1)-zqs(i,k1))*(pplev(i,k1)-pplev(i,k1+1))
       IF (zflo.LE.0.0 .OR. zsat.LE.0.0) GOTO 841 ! yes we have!
 
@@ -271,5 +240,5 @@
       k1 = k1 - 1
       IF (k1 .EQ. 1) GOTO 830 ! GOTO 820 (a tester, Z.X.Li, mars 1995)
-      zsat = zsat + (local_q(i,k1-1)-v_qs(i,k1-1))               &
+      zsat = zsat + (local_q(i,k1-1)-zqs(i,k1-1))               &
                   *(pplev(i,k1-1)-pplev(i,k1))
       zflo = v_cptt(i,k1-1) - v_cptt(i,k1) - gamcpdz(i,k1)
@@ -299,5 +268,5 @@
       DO i = 1, ngridmx
          IF (itest(i)) THEN
-         delta_q(i,k) = local_q(i,k) - q(i,k)
+         delta_q(i,k) = local_q(i,k) - zq(i,k)
          IF (delta_q(i,k).LT.0.) rneb(i,k)  = 1.0
          ENDIF
@@ -327,6 +296,5 @@
       DO i = 1, ngridmx
          IF (itest(i)) THEN
-         IF (zq2(i).NE.0.0) &
-           d_ql(i,k) = - MIN(0.0,delta_q(i,k))*zq1(i)/zq2(i)
+           IF (zq2(i).NE.0.0) d_ql(i,k) = - MIN(0.0,delta_q(i,k))*zq1(i)/zq2(i)
          ENDIF
       ENDDO
@@ -343,6 +311,6 @@
       DO k = 1, nlayermx
       DO i = 1, ngridmx
-         d_t(i,k) = local_t(i,k) - t(i,k)
-         d_q(i,k) = local_q(i,k) - q(i,k)
+         d_t(i,k) = local_t(i,k) - zt(i,k)
+         d_q(i,k) = local_q(i,k) - zq(i,k)
       ENDDO
       ENDDO
@@ -352,61 +320,11 @@
          DO i = 1, ngridmx
             
-            dtmana(i,k)       = d_t(i,k)/ptimestep
-            dqmana(i,k,i_h2o) = d_q(i,k)/ptimestep
-            dqmana(i,k,i_ice) = d_ql(i,k)/ptimestep
+            pdtmana(i,k)       = d_t(i,k)/ptimestep
+            pdqmana(i,k,i_h2o) = d_q(i,k)/ptimestep
+            pdqmana(i,k,i_ice) = d_ql(i,k)/ptimestep
          
          ENDDO
       ENDDO
 
-!      print*,'IN MANABE:'
-!      print*,'pplev=',pplev
-!      print*,'t=',t
-!      print*,'d_t=',d_t
-!      print*,'d_q=',d_q
-!      print*,'local_q=',local_q
-!      print*,'q=',q
-!      print*,'v_qs(i,k)=',v_qs
-!      print*,'v_qsd(i,k)=',v_qsd
-!      print*,'cp_delta_t(k)=',cp_delta_t
-
-!      print*,'d_ql=',d_ql
-!      print*,'delta_q=',delta_q
-!      print*,'zq1=',zq1
-!      print*,'zq2=',zq2
-!!      print*,'i_h2o=',i_h2o
-!      print*,'i_ice=',i_ice
-!
-!      print*,'IN MANABE:'
-!      print*,'d_q=',d_q
-!      print*,'d_ql=',d_ql
-!      print*,'dtmana=',d_t
-!     stop
-!      print*,'gamcpdz at end=',gamcpdz
-      !  stop    
-
-!     Some conservation diagnostics...
-!      dEtot=0.0
-!      dL1tot=0.0
-!      dL2tot=0.0
-!      dqtot=0.0
-!      masse=0.0
-!      DO k = 1, nlayermx
-!         DO i = 1, ngridmx
-!
-!            masse = (pplev(i,k) - pplev(i,k+1))/g
-!
-!            dEtot  = dEtot  + cpp*d_t(i,k)*masse
-!            dL1tot = dL1tot + RLVTT*d_ql(i,k)*masse
-!            dL2tot = dL2tot + RLVTT*d_q(i,k)*masse ! is this line necessary?
-!
-!            dqtot = dqtot + (d_q(i,k) + d_ql(i,k))*masse
-!
-!         ENDDO
-!      ENDDO
-
-!        print*,'In manabe energy change=',dEtot
-!        print*,'In manabe condense energy change 1 =',dL1tot
-!        print*,'In manabe condense energy change 2 =',dL2tot
-!        print*,'In manabe water change=',dqtot
 
       RETURN
Index: trunk/LMDZ.GENERIC/libf/phystd/phyetat0.F
===================================================================
--- trunk/LMDZ.GENERIC/libf/phystd/phyetat0.F	(revision 726)
+++ trunk/LMDZ.GENERIC/libf/phystd/phyetat0.F	(revision 728)
@@ -11,5 +11,5 @@
 #include "dimensions.h"
 #include "dimphys.h"
-!#include "comgeomfi.h"
+#include "comgeomfi.h"
 #include "surfdat.h"
 #include "planete.h"
@@ -111,53 +111,59 @@
      .              p_omeg,p_g,p_cpp,p_mugaz,p_daysec,time)
 c
-c Read latitudes (coordinates): No need, these are provided by the dynamics
-c
-!      ierr=nf90_inq_varid(nid,"latitude",nvarid)
-!      IF (ierr.NE.nf90_noerr) THEN
-!         PRINT*, 'phyetat0: Le champ <latitude> est absent'
-!         write(*,*)trim(nf90_strerror(ierr))
-!         CALL abort
-!      ENDIF
-!      ierr=nf90_get_var(nid,nvarid,lati)
-!      IF (ierr.NE.nf90_noerr) THEN
-!         PRINT*, 'phyetat0: Lecture echouee pour <latitude>'
-!         write(*,*)trim(nf90_strerror(ierr))
-!         CALL abort
-!      ENDIF
-c
-c read longitudes (coordinates): No need, these are provided by the dynamics
-c
-!      ierr=nf90_inq_varid(nid,"longitude",nvarid)
-!      IF (ierr.NE.nf90_noerr) THEN
-!         PRINT*, 'phyetat0: Le champ <longitude> est absent'
-!         write(*,*)trim(nf90_strerror(ierr))
-!         CALL abort
-!      ENDIF
-!      ierr=nf90_get_var(nid,nvarid,long)
-!      IF (ierr.NE.nf90_noerr) THEN
-!         PRINT*, 'phyetat0: Lecture echouee pour <longitude>'
-!         write(*,*)trim(nf90_strerror(ierr))
-!         CALL abort
-!      ENDIF
-c
-c Read areas of meshes: No need, these are provided by the dynamics
-c
-!      ierr=nf90_inq_varid(nid,"area",nvarid)
-!      IF (ierr.NE.nf90_noerr) THEN
-!         PRINT*, 'phyetat0: Le champ <area> est absent'
-!         write(*,*)trim(nf90_strerror(ierr))
-!         CALL abort
-!      ENDIF
-!      ierr=nf90_get_var(nid,nvarid,area)
-!      IF (ierr.NE.nf90_noerr) THEN
-!         PRINT*, 'phyetat0: Lecture echouee pour <area>'
-!         write(*,*)trim(nf90_strerror(ierr))
-!         CALL abort
-!      ENDIF
-!      xmin = 1.0E+20
-!      xmax = -1.0E+20
-!      xmin = MINVAL(area)
-!      xmax = MAXVAL(area)
-!      PRINT*,'Aires des mailles <area>:', xmin, xmax
+c Lecture des latitudes (coordonnees):
+c
+      ierr = NF_INQ_VARID (nid, "latitude", nvarid)
+      IF (ierr.NE.NF_NOERR) THEN
+         PRINT*, 'phyetat0: Le champ <latitude> est absent'
+         CALL abort
+      ENDIF
+#ifdef NC_DOUBLE
+      ierr = NF_GET_VAR_DOUBLE(nid, nvarid, lati)
+#else
+      ierr = NF_GET_VAR_REAL(nid, nvarid, lati)
+#endif
+      IF (ierr.NE.NF_NOERR) THEN
+         PRINT*, 'phyetat0: Lecture echouee pour <latitude>'
+         CALL abort
+      ENDIF
+c
+c Lecture des longitudes (coordonnees):
+c
+      ierr = NF_INQ_VARID (nid, "longitude", nvarid)
+      IF (ierr.NE.NF_NOERR) THEN
+         PRINT*, 'phyetat0: Le champ <longitude> est absent'
+         CALL abort
+      ENDIF
+#ifdef NC_DOUBLE
+      ierr = NF_GET_VAR_DOUBLE(nid, nvarid, long)
+#else
+      ierr = NF_GET_VAR_REAL(nid, nvarid, long)
+#endif
+      IF (ierr.NE.NF_NOERR) THEN
+         PRINT*, 'phyetat0: Lecture echouee pour <longitude>'
+         CALL abort
+      ENDIF
+c
+c Lecture des aires des mailles:
+c
+      ierr = NF_INQ_VARID (nid, "area", nvarid)
+      IF (ierr.NE.NF_NOERR) THEN
+         PRINT*, 'phyetat0: Le champ <area> est absent'
+         CALL abort
+      ENDIF
+#ifdef NC_DOUBLE
+      ierr = NF_GET_VAR_DOUBLE(nid, nvarid, area)
+#else
+      ierr = NF_GET_VAR_REAL(nid, nvarid, area)
+#endif
+      IF (ierr.NE.NF_NOERR) THEN
+         PRINT*, 'phyetat0: Lecture echouee pour <area>'
+         CALL abort
+      ENDIF
+      xmin = 1.0E+20
+      xmax = -1.0E+20
+      xmin = MINVAL(area)
+      xmax = MAXVAL(area)
+      PRINT*,'Aires des mailles <area>:', xmin, xmax
 c
 c Lecture du geopotentiel au sol:
